<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Language Library</h1>

		<p>The language library provides an interface to retrieve language files and lines of text for the sole
		purpose of internationalisation.</p>

		<p>In the CarbonPHP directory there is a directory called <b>languages</b> containing language files.  You
		can create your own language files as needed in order to display errors and other messages in other
		languages.</p>

		<p>Languages are typically stored in <b>carbon/languages/</b>.  You can alternately create a directory called
		<b>languages</b> in your application directory.  CarbonPHP will look in the <b>application/languages/</b>
		directory first.  <i>Note</i>: each language should be stored in its own directory.  For example <b>english</b>
		language files will be stored in <b>carbon/languages/english/</b>.</p>
	</div>

	<div class="content">
		<h1>Creating Language Files</h1>

		<p>Language files must be named with <b>_lang.php</b> at the end.  For example if you wanted a language file to
		contain error messages, you might name it <b>error_lang.php</b>.  Within the file you will assign each line
		of text to an array called <b>$lang</b>.</p>

		<div class="example">
			$lang['lang_key'] = 'This is a message in the language.';
		</div>

		<p><i>Note</i>: it is good practice to prefix your array keys to avoid collisions with similarly named items
		that could be in other files.  For example in the error language file you could do something like the
		following.</p>

		<div class="example">
			$lang['error_missing_url'] = 'The URL is missing';<br />
			$lang['error_missing_input'] = 'The input is missing';<br />
			$lang['error_missing_output'] = 'The output is missing';
		</div>
	</div>

	<div class="content">
		<h1>Loading Language Files</h1>

		<p>In order to retrieve lines from a language file you must load the file.</p>

		<div class="example">
			$this->lang->load('<b>filename</b>', '<b>language</b>');
		</div>

		<p>Where <b>filename</b> is the name of the file you wish to load, without the file extension, and
		<b>language</b> is the language set you want to load for example english.  If the second parameter is not
		specified the default language from <b>application/config/config.php</b> will be used.</p>
	</div>

	<div class="content">
		<h1>Retrieving a Line of Text</h1>

		<p>Once you have loaded the language file you can retrieve any line of text from the file.</p>

		<div class="example">
			$this->lang->line('<b>lang_key</b>');
		</div>

		<p>Where <b>lang_key</b> is the array key of the line of text you wish to retrieve.  <i>Note</i>: this method
		only returns the line, it does not echo it for you.</p>
	</div>

	<div class="content">
		<h1>Automatically Loading Language Files</h1>

		<p>You may find yourself loading a language file throughout your application, you can automatically load it
		you can add it to the <b>application/config/autoload.php</b> configuration file.</p>
	</div>
</body>

</html>
